package ru.dbotthepony.kstarbound


import org.apache.logging.log4j.LogManager
import org.lwjgl.Version
import ru.dbotthepony.kommons.vector.Vector2d
import ru.dbotthepony.kommons.vector.Vector2i
import ru.dbotthepony.kstarbound.client.StarboundClient
import ru.dbotthepony.kstarbound.io.BTreeDB
import ru.dbotthepony.kstarbound.server.IntegratedStarboundServer
import ru.dbotthepony.kstarbound.server.world.LegacyChunkSource
import ru.dbotthepony.kstarbound.server.world.ServerWorld
import ru.dbotthepony.kstarbound.world.WorldGeometry
import ru.dbotthepony.kstarbound.world.entities.ItemEntity
import java.io.BufferedInputStream
import java.io.ByteArrayInputStream
import java.io.DataInputStream
import java.io.File
import java.util.*
import java.util.concurrent.TimeUnit
import java.util.zip.Inflater
import java.util.zip.InflaterInputStream

private val LOGGER = LogManager.getLogger()

fun main() {
	LOGGER.info("Running LWJGL ${Version.getVersion()}")

	//Thread.sleep(6_000L)

	val db = BTreeDB(File("F:\\SteamLibrary\\steamapps\\common\\Starbound - Unstable\\storage\\universe\\389760395_938904237_-238610574_5.world"))
	//val db = BTreeDB(File("world.world"))

	val meta = DataInputStream(BufferedInputStream(InflaterInputStream(ByteArrayInputStream(db.read(byteArrayOf(0, 0, 0, 0, 0))), Inflater())))

	println(meta.readInt())
	println(meta.readInt())

	// println(VersionedJson(meta))

	val server = IntegratedStarboundServer(File("./"))
	val client = StarboundClient.create().get()
	val world = ServerWorld(server, 0L, WorldGeometry(Vector2i(3000, 2000), true, false))
	world.addChunkSource(LegacyChunkSource(db))
	world.startThread()

	//Starbound.addFilePath(File("./unpacked_assets/"))
	Starbound.addPakPath(File("J:\\Steam\\steamapps\\common\\Starbound\\assets\\packed.pak"))

	/*for (folder in File("J:\\Steam\\steamapps\\workshop\\content\\211820").list()!!) {
		val f = File("J:\\Steam\\steamapps\\workshop\\content\\211820\\$folder\\contents.pak")

		if (f.exists()) {
			Starbound.addPakPath(f)
		}
	}*/

	//Starbound.addPakPath(File("packed.pak"))

	Starbound.initializeGame()

	Starbound.mailboxInitialized.submit {
		//ply = PlayerEntity(client.world!!)

		//ply!!.position = Vector2d(225.0, 680.0)
		//ply!!.spawn()

		//client.world!!.parallax = Starbound.parallaxAccess["garden"]

		val rand = Random()

		for (i in 0 until 0) {
			val item = ItemEntity(world, Registries.items.keys.values.random().value)

			item.position = Vector2d(225.0 - i, 785.0)
			item.spawn()
			item.movement.velocity = Vector2d(rand.nextDouble() * 32.0 - 16.0, rand.nextDouble() * 32.0 - 16.0)

			item.mailbox.scheduleAtFixedRate({ item.movement.velocity += Vector2d(rand.nextDouble() * 32.0 - 16.0, rand.nextDouble() * 32.0 - 16.0) }, 1000 + rand.nextLong(-100, 100), 1000 + rand.nextLong(-100, 100), TimeUnit.MILLISECONDS)
			//item.movement.applyVelocity(Vector2d(rand.nextDouble() * 1000.0 - 500.0, rand.nextDouble() * 1000.0 - 500.0))
		}

		client.connectToLocalServer(server.channels.createLocalChannel(), UUID.randomUUID())
	}

	//ent.position += Vector2d(y = 14.0, x = -10.0)
	client.camera.pos = Vector2d(238.0, 685.0)
	//client.camera.pos = Vector2f(0f, 0f)

	//ent.spawn()
}
