package ru.dbotthepony.kstarbound.world.api

import ru.dbotthepony.kommons.core.IStruct2i
import ru.dbotthepony.kommons.vector.Vector2i

class OffsetCellAccess(private val parent: ICellAccess, var x: Int, var y: Int) : ICellAccess {
	constructor(parent: ICellAccess, offset: IStruct2i) : this(parent, offset.component1(), offset.component2())

	override fun getCell(x: Int, y: Int): AbstractCell {
		return parent.getCell(x + this.x, y + this.y)
	}

	override fun getCellDirect(x: Int, y: Int): AbstractCell {
		return parent.getCellDirect(x + this.x, y + this.y)
	}

	override fun setCell(x: Int, y: Int, cell: AbstractCell): Boolean {
		return parent.setCell(x, y, cell)
	}

	override fun randomLongFor(x: Int, y: Int) = parent.randomLongFor(x + this.x, y + this.y)
	override fun randomDoubleFor(x: Int, y: Int) = parent.randomDoubleFor(x + this.x, y + this.y)
	override fun randomLongFor(pos: Vector2i) = parent.randomLongFor(pos.x + this.x, pos.y + this.y)
	override fun randomDoubleFor(pos: Vector2i) = parent.randomDoubleFor(pos.x + this.x, pos.y + this.y)
}